#include <bits/stdc++.h>

using namespace std;
#define N_MAX 500005
int a[N_MAX],n,k;
bool ne_ispisati[N_MAX];

int main()
{
    int i;
    ios::sync_with_stdio(false);
    cin>>n>>k;
    cin>>a[1];
    for(i=2;i<=n;i++) cin>>a[i];
    i=1;
    while(k>0 && i<n)
    {
        while(i<n && a[i]<a[i+1]) i++;
        if(i<n)
        {
            ne_ispisati[i]=true;
            k--;
            i++;
        }
    }
    if(k>0 && i==n)
    {
        while(k>0)
        {
            while(ne_ispisati[i]) i--;
            ne_ispisati[i]=true;
            k--;
        }
    }
    for(i=1;i<=n;i++) if(!ne_ispisati[i]) cout<<a[i]<<" ";
    return 0;
}